#if 0 /*
#  This is a C/MPW script hybrid!
# Just execute this on the MPW command line, as is - Really!

Unset 1; (Evaluate "{0}"=~/()1./) dev:null; Set Targ "{1}"
Set COptions "-mc68040 -b2 -sym off -proto strict -opt speed -load "{CHeaders}"Headers68K"
SC "{0}" -o "{0}".o {COptions}
ILink -o "{Targ}" "{0}".o -t 'MPST' -c 'MPS ' -compact -pad 0 -state nouse -br 020 
  "{Libraries}"MacRuntime.o "{CLibraries}"StdCLib.o "{Libraries}"Interface.o 
  "{Libraries}"IntEnv.o "{Libraries}"ToolLibs.o "{Libraries}"MathLib.o 
  -sn %A5Init=Main -sn INTENV=Main -sn SADEV=Main -sn STDCLIB=Main -sn STDIO=Main 
  -sn SANELIB=Main -sn CSANELib=Main
Delete -i "{0}".o
Exit 0
# */
#endif

/*
 cpager.c
  Packager.

  Version: 0.1
  Created: 2008.04.16 17:57 GMT
  Revised: 2008.05.07 04:47 GMT
*/

#include <stdio.h>
#include <stdlib.h> /* only for realloc */
#include <string.h>
/*#include <ctype.h>*/
#include <errno.h>

#include <MacMemory.h>
#include <MacErrors.h>

#include <FSpio.h>

#if TARGET_OS_MAC
# define commandPeriod()				((*((volatile UInt8*)0x179)&*((volatile UInt8*)0x17A))!=0)
#else
# define commandPeriod()				0 /* you lose */
#endif

#define _PATH_SEPERATOR					':'
#define PATH_SEPERATOR					":"

/* ---- macros */

#define vdispose(a,c)					do{c=0; if(a!=NULL) {free(a); a=NULL;}}while(0)

#define vpushback(a,c,x)				do{void*_tmpp=a; if(c<0) c=0; \
	if(((c&7)==0||a==NULL)&&(_tmpp=realloc(a,(c+8)*sizeof(*a)))==NULL) \
		{fputs("### vpushback: could not reallocate",stderr); goto cancel;} \
	(a=_tmpp)[c]=x; if(++c<=0) {fputs("### vpushback: count overflow",stderr); \
	goto cancel;}}while(0)

/* C-string List */
#define slpushback(a,x)				do{void*_tmpp; long _tmpl,_tmpz,_tmpt; \
	if((_tmpp=a)==NULL) _tmpz=4; else _tmpz=*(SInt32*)_tmpp; \
	if(_tmpz<4) _tmpz=4; if((_tmpl=1+strlen(x))<=0||(_tmpt=_tmpz+_tmpl)<=0) \
		{fputs("### slpushback: size overflow",stderr); goto cancel;} \
	if((_tmpp=realloc(a,_tmpt))==NULL) \
		{fputs("### slpushback: could not reallocate",stderr); goto cancel;} \
	memcpy(_tmpz+(a=_tmpp),x,_tmpl); *(SInt32*)_tmpp=_tmpt;}while(0)

/* ---- globals */

UInt8			temporary[1024] = {0}; /* 1KB */

static Boolean		user_abort = false;

static long			label_counter = 0, module_counter = 0, code_ref_counter = 0;
static long			trailer_count = 0, code_relocation_count = 0;
static long			anon_count = 0, branch_island_count = 0, case_count = 0;
static long			**stored_offsets = NULL, stored_offset_count = 0;

/* ---- support code */

static void global_idle_proc()
{
	if (user_abort)
	{
		fputs("\n### User abort.\n",stderr);
		exit(1);
	}
	if (commandPeriod())
		user_abort = true;
}

UInt32 calculate_crc32(void *data, long count, UInt32 crc)
{ /* crc32 code self contained! */
	static UInt32	crc_table[256] =
	{
		0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
		0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
		0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
		0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,
		0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
		0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
		0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
		0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,
		0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
		0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
		0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
		0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,
		0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
		0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
		0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
		0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,
		0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
		0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
		0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
		0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,
		0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
		0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
		0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
		0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,
		0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
		0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
		0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
		0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,
		0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
		0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
		0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
		0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,
		0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
		0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
		0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
		0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,
		0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
		0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
		0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
		0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,
		0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
		0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
		0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
		0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,
		0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
		0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
		0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
		0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,
		0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
		0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
		0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
		0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,
		0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
		0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
		0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
		0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,
		0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
		0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
		0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
		0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
		0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
		0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
		0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
		0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D,
	};

	UInt8			*p = (UInt8*)data;

	do{crc = ((crc>>8)&0x00FFFFFFL)^crc_table[((UInt8)crc^*p++)];} while(--count!=0);

	return crc;
}

long int read_any_integer(const char *_s)
{
	UInt8			*s, c;

	unsigned long int	r = 0, m = 0;

	if ((s=(UInt8*)_s)==NULL || (c=*s++)==0)
		return INT_UNDEF;
	if ((c+=-'-')==0)
	{
		m = -1;
		if ((c=*s++)==0)
			return INT_UNDEF;
	} else if ((c+='-'-'+')==0)
	{
		if ((c=*s++)==0)
			return INT_UNDEF;
	} else if ((UInt8)((c+='+')-'0')>(UInt8)('9'-'0'))
		return INT_UNDEF;
	if (c=='0')
	{
		if ((c=*s++)==0)
			return 0;
		if (c!='x' && c!='X')/*goto skip_dec;*/
		{ /* octal */
			do
			{
				if ((c+=-'0')>7)
					if (c<=(UInt8)('9'-'0') || (c+='0'-'A')<=(UInt8)('Z'-'A')
							|| (c+='A'-'a')<=(UInt8)('z'-'a') || (c+='a'-'_')==0)
						return INT_UNDEF;
					else
						break;
				r = r*8+c;
			} while((c=*s++)!=0);
		} else
		{ /* hexadecimal */
			if ((c=*s++)==0)
				return INT_UNDEF;
			do
			{
				if ((c+=-'0')<=(UInt8)('9'-'0'))
					r = r*16+c;
				else if ((c+='0'-'A')<=(UInt8)('Z'-'A') || (c+='A'-'a')<=(UInt8)('z'-'a'))
					if (c>(UInt8)('F'-'A'))
						return INT_UNDEF;
					else
						r = r*16+c+10;
				else if ((c+='a'-'_')==0)
					return INT_UNDEF;
				else
					break;
			} while((c=*s++)!=0);
		}
	} else
	{ /* decimal */
		do
		{
			c += -'0';
			if (c>(UInt8)('9'-'0'))
				if ((c+='0'-'A')<=(UInt8)('Z'-'A') || (c+='A'-'a')<=(UInt8)('z'-'a')
						|| (c+='a'-'_')==0)
					return INT_UNDEF;
				else
					break;
			r = r*10+c;
		} while((c=*s++)!=0);
	}

	return r=(r^m)-m;
}

/* ---- program code */

static int mkdir(const char *path)
{
}

static int expand_file(const char *dirpath,
	int dirlength,
	const char *name,
	FILE *stream,
	long size,
	int format)
{
	FILE			*dstfile;
	int				length;
	char			cr_char, dr_char = 0x0C;

	switch(format)
	{
	case 1: case 2: cr_char = 0xC8, dr_char = 0xC7; break;
	case 4: dr_char = 0x0D; case 3: cr_char = 0x0D; break;

	default:
		return -50;
	}

	memcpy(temporary,src_files,dirlength);
	strcpy(dirlength+temporary,name);
	if ((dstfile=fopen(temporary,"wb"))==NULL)
		return errno;
	if (size<0)
	{
		int			c;
#if (unsigned char)EOF==(unsigned char)(-1)
		while((unsigned char)(c=fgetc(stream))!=(unsigned char)EOF)
#else
		while((c=fgetc(stream))!=EOF && c!=(unsigned char)(-1))
#endif
		{
			if (c==cr_char)
				c = '\n';
			else if (c==dr_char)
				fputc(c='\n',dstfile);
			fputc(c,dstfile);
		}
	} else if (dr_char==0x0D)
	{
		long		remaining = size;

		while(remaining>0 && (length=fread(temporary,1,MIN(1024,remaining),stream))>0)
			fwrite(temporary,1,length,dstfile);
	} else
		while((c=fgetc(stream))!=EOF)
		{
			if (c==cr_char)
				c = '\n';
			else if (c==dr_char)
				fputc(c='\n',dstfile);
			fputc(c,dstfile);
		}
cancel:
	if (dstfile!=NULL)
		fclose(dstfile);

	return 0;
}

#define MAXIMUM_FILEPATH_LENGTH			300
#define MAXIMUM_TITLE_LENGTH			50
#define MAXIMUM_NAME_LENGTH				31

static int expand_files(const char *src_files,
	const char *dirpath,
	const char *onlyname,
	boolean indir)
{
	char			path[MAXIMUM_FILEPATH_LENGTH+MAXIMUM_NAME_LENGTH+1];

	FILE			*stream;
	const char		*src_files_end = src_files, *d;
	int				err = 0, dirlength = dirpath==NULL ? 0:strlen(dirpath);

	src_files_end += *((SInt32*)src_files)++;
	do
	{
		char		name[MAXIMUM_NAME_LENGTH+1];
		long		size = -1L;
		int			c, format, titlelength;

		if ((stream=fopen(src_files,"r"))==NULL)
			return errno;
		if ((format=fgetc(stream))==EOF || fgets(name,MAXIMUM_NAME_LENGTH,stream)==NULL)
			{err = EOF; goto cancel;}
		/* concatenate name with destination path */
		memcpy(d=path,dirpath,dirlength);
		d += dirlength;
		if (!indir)
		{
			memcpy(d,name,titlelength);
			d += titlelength, *d = 0;
			if ((err=mkdir(path))!=0)
				goto cancel;
		} else
			*d = 0;
		while((err=expand_file(path,d-path,name,stream,size,format))==0) ;
		fclose(stream); stream = NULL;
		if (err<0)
			break;
		src_files += strlen(src_files);
	} while(src_files<src_files_end);
cancel:
	if (stream!=NULL)
		fclose(stream);

	return err;
}

static int merge_files(const char *src_files,
	const char *outpath,
	const char *outtitle,
	int format)
{
	FILE			*dstfile;
	const char		*src_files_end = src_files;
	int				length;

	if (outtitle==NULL)
	{ /* default title -- get the name of the file (sans path) */
		const char		*s = strlen(outpath)+outpath;

		do{if (*--s==_PATH_SEPERATOR) {++s; break;}} while(s>outpath);
		outtitle = s;
	}

	if ((dstfile=fopen(,"wb+"))==NULL)
		return errno;
	src_files_end += *((SInt32*)src_files)++
	do
	{
		length = strlen(src_files);
		src_files += length;
	} while(src_files<src_files_end);
cancel:
	if (dstfile!=NULL)
		fclose(dstfile);

	return 0;
}

/* ---- main code */

/* these macros eliminate usage of strcmp altogether */
#define _sceq(x,s)						(memcmp(x,s,sizeof(s))==0)
#define _sdceq(x,s,d)					(memcmp(x,s,sizeof(s)-d)==0)
#define _soption(x,s)					(memcmp(x,s,(slen=sizeof(s))-1)==0 \
	&& ((const char*)(x)[sizeof(s)-1]==0 || (const char*)(x)[sizeof(s)-1]==',')

static int cpager_expand(int argc, char **argv)
{
	char			**a = 1+argv, *s = NULL, *src_files = NULL;
	char			*onlyname = NULL, *dirpath = NULL;
	int				err = 0, c = argc, format = 0, slen = 0;
	boolean			indir = false, listonly = false;

	if (--c<=1)
	{
		fputs(
"#\n"
"# mode '-expand'\n"
			,stderr);
		goto dish;
	}

	while(--c!=0)
	{
		global_idle_proc();
		if (user_abort)
			goto cancel;
		if (*(s=*++a)!='-')
		{
			if (strlen(s)>MAXIMUM_FILEPATH_LENGTH)
			{
				fprintf(stderr,"### %s - filepath is too long\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
			slpushback(src_files,s);
		}
		if (_sceq(++s,"only")==0)
		{
			if (--c==0)
				goto missing;
			onlyname = ++a;
		} else if (_sceq(s,"dstdir")==0)
		{
			if (--c==0)
			{
			missing:
				fprintf(stderr,"### %s - '%s' needs a parameter\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
			if (dirpath!=NULL)
			{
				fprintf(stderr,"### %s - '%s' directorypath already defined\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
			if (strlen(dirpath=++a)>MAXIMUM_FILEPATH_LENGTH)
			{
				fprintf(stderr,"### %s - '%s' directorypath is too long\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
		} else if (_sceq(s,"indir"))
			indir = true;
		else if (_sceq(s,"list"))
			listonly = true;
		else
		{
			fprintf(stderr,"### %s - unrecognized option '%s'\n", argv[0],--s);
			err = 1;
			goto cancel;
		}
	}
	if (src_files!=NULL)
	{
		if ((err=expand_files(src_files,dirpath,onlyname,format,indir,listonly))!=0)
			fprintf(stderr,"### %s error (%d)\n", argv[0],err);
	cancel:
		free(src_files);
		return err;
	}
usage:
	fprintf(stderr,"### usage: %s -expand parameters\n", argv[0]);
dish:
	fputs(
"#\n"
"# mode '-expand'\n"
"#  [option...] srcfile\n"
"#\n"
"#-dstdir path       set destination directory (default: current)\n"
"#-indir             don't add new directory for title (all files -> dstdir)\n"
"#                     -- default: add new directory for file(s)\n"
"#-list              list files (only)\n"
"#-only name         extract only this file\n"
"#\n"
		,stderr);

	return 1;
}

#define DEFAULT_OUT_PATH				"cpager.out"

static int cpager_merge(int argc, char **argv)
{
	const char		*default_outpath = DEFAULT_OUT_PATH;
	const char		*outpath = default_outpath, *outtitle = NULL;
	char			**a = 1+argv, *s = NULL, *src_files = NULL;
	int				err = 0, c = argc, format = 0, slen = 0; /*src_file_count = 0*/

	if (--c<=1)
	{
		fputs(
"#\n"
"# mode '-merge'\n"
			,stderr);
		goto dish;
	}

	while(--c!=0)
	{
		global_idle_proc();
		if (user_abort)
			goto cancel;
		if (*(s=*++a)!='-')
			slpushback(src_files,s);
		else if (*++s=='o' && s[1]==0) || _sceq(s,"output"))
		{
			if (outpath!=default_outpath)
			{
				fprintf(stderr,"### %s - '%s' path already defined\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
			if (--c==0)
				goto missing;
			outpath = ++a;
		} else if (_sceq(s,"format"))
		{
			if (--c==0)
			{
			missing:
				fprintf(stderr,"### %s - '%s' needs a parameter\n", argv[0],--s);
				err = 1;
				goto cancel;
			}
			if ((unsigned)((format=read_any_integer(*++a)-1)>2)
			{
				fprintf(stderr,"### %s - format %d not supported\n", argv[0],format);
				err = 1;
				goto cancel;
			}
		} else
		{
			fprintf(stderr,"### %s - unrecognized option '%s'\n", argv[0],--s);
			err = 1;
			goto cancel;
		}
	}

	if (src_files!=NULL)
	{
		if ((err=merge_files(src_files,outpath,outtitle,format))!=0)
			fprintf(stderr,"### %s error (%d)\n", argv[0],err);
	cancel:
		free(src_files);
		return err;
	}
usage:
	fprintf(stderr,"### usage: %s -merge parameters\n", argv[0]);
dish:
	fputs(
"#  [option] srcfile [option | srcfile] ...\n"
"#\n"
"#-format value      write output file in format xxx (default: 3)\n"
"#                    formats supported:\n"
"#                     1: no header, CR: , double CR: , page break: 0xFF\n"
"#                     2: file list header, CR: , double CR: , page break: 0xFF\n"
"#                     3: file list header, CR: CR, double CR: 0x0C, page break: 0xFF\n"
"#                     4: binary list header\n"
"#-output | -o       output filepath (default: '" DEFAULT_OUT_PATH "')\n"
"#\n"
		,stderr);
	return 1;
}

void main(int argc, char **argv)
{
	int				err = 0;

	if (argc<=1 || argv[1][0]!='-')
	{
		if (argc>0)
			goto dish;
	} else
	{
		if (_sceq(argv[1]+1,"merge"))
			err = cpager_merge(argc,argv);
		else if (_sceq(argv[1]+1,"expand"))
			err = cpager_expand(argc,argv);
		else
		{
		dish:
			fprintf(stderr,"### usage: %s mode parameters\n", argv[0]);
			cpager_merge(0,NULL);
			cpager_expand(0,NULL);
		}
	}

	exit(err==0 ? 0:1);
}
#endif/*!defined(DISASM_EXTENSIONS)*/
