/*
 sbcp.c (of what was the "tester")
  wholey crap, batman! -- executable interface

  Created: November 26, 2007 3:10 AM EDST
  Revised: December 21, 2007 11:50 AM EDST

 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.

Tuesday, December 4, 2007 11:17 AM
A.P.: print_lines also counts in non-silence.
1:04 PM
  difficulties getting fgets - sorry, read_first_line to work the way i want it to.
*/

#define DEBUG							1

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>

#include "sbcp.h"
#include "sbcp_core.h"
#include "sbcp_utils.h"

#if TARGET_OS_MAC
# include <MacMemory.h>

# define memerr							MemError()
# if TARGET_API_MAC_CARBON
#  define syserr						errno
# else
#  define syserr						(0+MacOSErr)
# endif
#else
# define memerr							errno
# define syserr							(0+errno)
#endif

#if TARGET_OS_MAC
# define commandPeriod()				(*((volatile char*)0x179)&*((volatile char*)0x17A))
#else
# define commandPeriod()				0 /* you lose */
#endif

/* ---------- constants */

#ifndef __CMD_INDENT_STR
# define __CMD_INDENT_STR				"> "
#endif
#ifndef __ERR_INDENT_STR
# define __ERR_INDENT_STR				" "
#endif

/* ---------- globals */

static boolean		fall_silent = false, user_abort = false;

static _uint8		*total_code = NULL;
static long int		total_code_length = 0;

/* ---------- code */

static void global_idle_proc()
{
	if (!commandPeriod() && !user_abort)
		return;

	if (user_abort)
	{
		fputs("\n### User abort.",stderr);
		exit(1);
	}
	user_abort = true;
}

static boolean user_aborted()
{
	return user_abort;
}

static void fprint_string(const char *str, FILE *stream)
{
	if (!fall_silent)
		fputs(str,stream);
}

static void fprint_form(FILE *stream, const char *form, ...)
{
	va_list			args;

	if (fall_silent)
		return;

	va_start(args,form);
	vfprintf(stream,form,args);
	va_end(args);
}

static void fatal_memory_error(int x)
{
	fflush(stdout);
	fprint_form(stderr,"### out of memory (%d)\n", x);
	exit(1);
}

static void print_signature(void)
{
	fprint_string(__ERR_INDENT_STR " " SBCP_NAME_STRING " " SBCP_VERSION_STRING,stderr);
}

/* ---------- memory partitioning */

#define MAXIMUM_MEMORY_PARTITIONS		8 /* set to whatever you pleaz */

static int			memory_partition_count = 0;

typedef struct memory_partition/*(8+)*/
{
	_uint8			*allocation;
	long			size; /* negative represents unwritable space (negate for size) */
} memory_partition;

memory_partition	memory_partitions[MAXIMUM_MEMORY_PARTITIONS];

static void unload_memory_partitions(void)
{
	memory_partition	*part = memory_partitions;

	if (memory_partition_count<=0)
		return;
	do
	{
		/*if (part->size>=0)*/
		free(part->allocation); part->allocation = NULL;
		++part;
	} while(--memory_partition_count!=0);
}

/* used to get the highest or lowest partition (for map creation) */
static _uint8 *get_edge_partition(boolean highest)
{
	memory_partition	*part = memory_partitions;

	_uint8			*pointer = highest ? (_uint8*)-1UL:(_uint8*)NULL;
	int				count = memory_partition_count;

	if (memory_partition_count<=0)
		return NULL;
	if (highest)
		do
		{
			if (part->allocation>pointer)
				pointer = part->allocation;
			++part;
		} while(--count!=0);
	else
		do
		{
			if (part->allocation<pointer)
				pointer = part->allocation;
			++part;
		} while(--count!=0);

	return (_uint8*)(~0xFFFF&(0xFFFF+(long int)pointer));
}

/*
   Formerly as "make_memory_partition" and "pointer_to_memory_partition",
 seperately, this function adds a memory partition to the mix; otherwise.
 Passing a negative value to size, reallocates the passed pointer as one
 allocated with malloc/realloc.  In other words, don't pass a static pointer
 with a negative size (pass a positive value to copy to a new pointer).

   It returns the lowest pointer with a physical address with no lower 16
 bits within the allocation.  (I cannot recall the appropriate word for it)
*/
static _uint8 *reallocate_memory_partition(void *pointer,
	long size,
	boolean writable)
{
	memory_partition	*part = memory_partitions;

	void			*tmpp = NULL, *oldp = pointer;
	int				count;

	if ((count=memory_partition_count)>=MAXIMUM_MEMORY_PARTITIONS)
		return NULL;
	if (size<=0)
	{
		size = -size;
		if ((tmpp=realloc(pointer,0xFFFF+size))==NULL)
			return NULL;
		pointer = tmpp;
		memmove((_uint8*)(~0xFFFF&(0xFFFF+(long int)pointer)),pointer,size);

		/* remap old pointers */
		do
		{
			if (part->allocation==oldp)
				part->allocation = pointer;
			++part;
		} while(--count!=0);
	} else
	{
		if ((tmpp=malloc(0xFFFF+size))==NULL)
			return NULL;
		if (pointer==NULL)
			memset(tmpp,0,0xFFFF+size); /* cleared automatically */
		else
			memcpy((_uint8*)(~0xFFFF&(0xFFFF+(long int)tmpp)),pointer,-size);
		pointer = tmpp;
	}

	part = memory_partitions-1;
	part += ++memory_partition_count;
	part->allocation = pointer;
	part->size = writable ? size:-size;

	return (_uint8*)(~0xFFFF&(0xFFFF+(long int)pointer));
}

static _uint8 *make_partition_map(_uint8 *base, long *out_size)
{
	memory_partition	*part = memory_partitions;

	_uint8			*map;
	long int		high = get_edge_partition(true)-base;
	int				count, size;

	if (out_size!=NULL)
		*out_size = 0;

	/*if ((unsigned)(memory_partition_count-1)>=MAXIMUM_MEMORY_PARTITIONS)*/
	if ((count=memory_partition_count)<=0
			|| (map=malloc(size=1+((high-(get_edge_partition(false)-base))>>16)))==NULL)
		return NULL;
	memset(map,0,size);

	if (out_size!=NULL)
		*out_size = size;
	do
	{
		long int	location = part->allocation-base;

		if (location>=0 && location<high)
		{
			location = (location+0xFFFF)>>16;
			if ((size=part->size)>=0) /* writable (set bit 7 to one) */
				memset(location+map,0xFF,(0xFFFF+size)>>16);
			else /* unwritable (set bit 7 to zero) */
				memset(location+map,0x7F,(0xFFFF+-size)>>16);
		}
		++part;
	} while(--count!=0);

	return map;
}

/* ---------- main code */

static void print_instruction(_uint8 *line, long position)
{
	char			buf[100];

	sbcp_disassemble(&line,buf,buf+32,buf+64,position);
	printf("%08X  %s  %-19s|%s\n", position,buf,buf+32,buf+64);
}

static void disassemble_code(_uint8 *code,
	long length,
	long position,
	FILE *stream)
{
	char			buf[100];

	_uint8			*s = code, *e = length+code;

	if (position<0)
	{ /* got an unusable offset; print in a form that recognizes only displacement */
		fprint_string("disassembling code:\n",stream);
		while(s<e)
		{
			global_idle_proc();
			sbcp_disassemble(&s,buf,buf+32,buf+64,position=e-s);
			fprint_form(stream,"+%07X  %s  %-19s|%s\n", position,buf,buf+32,buf+64);
		}
	} else
	{
		code -= position;
		fprint_form(stream,"disassembling code from start %08X:\n", position);
		while(s<e)
		{
			global_idle_proc();
			sbcp_disassemble(&s,buf,buf+32,buf+64,position=s-code);
			fprint_form(stream,"%08X  %s  %-19s|%s\n", position,buf,buf+32,buf+64);
		}
	}
}

static const char *execution_error_string(int err)
{
	switch(err)
	{
	case _err_null_pointer: return "a null pointer was passed to sbcp_execute_lines";
	case _err_floor_above_ceiling: return "state floor was above ceiling";
	case _err_stack_overflow: return "stack overflow (DS or LS)";
	case _err_stack_underflow: return "stack underflow (DS or LS)";
	case _err_sensitive_register: return "instruction tried to set a sensitive register";

	case ~_ev_access_fault: return "access fault (attempted read from unmapped memory)";
	case ~_ev_write_fault: return "write fault (attempted to write to unmapped or unwritable memory)";
	case ~_ev_illegal_opcode: return "opcode is bad or unimplemented";
	case ~_ev_illegal_address: return "bad destination pointer";
	case ~_ev_stack_overflow: return "DS and/or LS went below floor";
	case ~_ev_stack_underflow: return "DS and/or LS went above ceiling";
	case ~_ev_outside_frame: return "stack frame index/offset is out of bounds";
	case ~_ev_non_integeral: return "value has a fraction; operation calls for an integer";
	case ~_ev_execution_fault: return "last resort (worst case scenario)";
	case ~_ev_privileged: return "operation is priviledged (cant just muck around)";
	case ~_ev_math_exception: return "division by zero, sqrt(-1), etc.";
	case ~_ev_trap_vector: return "debugger trap (unimplemented if you are reading this)";

	default: return "unknown emulator error";
	}
}

#define DEFAULT_V1_SIZE					(128*4)

/* this may call realloc, so whatever you do, don't pass a static pointer
  or master pointer */
static int execute_code(_uint8 *code,
	long code_length,
	int data_count,
	int link_count,
	long step_count,
	boolean print_lines)
{
	sbcp_state		*state;
	_uint8			*instructions, *map, *stacks;
	long			size = DEFAULT_V1_SIZE, zdata, zlink;
	long			steps = step_count<=0 ? LONG_MAX:step_count;
	int				err = 0;

	if (data_count<=0)
		data_count = 8192;
	zdata = data_count*sizeof(double);

	if (link_count<=0)
		link_count = 4096;
	zlink = link_count*sizeof(sbcp_link);

#if TARGET_OS_MAC && DEBUG
	Debugger();
#endif
	if ((state=malloc(sizeof(*state)))==NULL)
		{fatal_memory_error(memerr); goto end;}
	if ((stacks=reallocate_memory_partition(NULL,size+=zdata+zlink,false))==NULL)
		{fatal_memory_error(memerr); goto end;}

	if ((instructions=reallocate_memory_partition(code,-code_length,false))==NULL)
		return memerr;
	if ((1&(int)code)!=0) /* if the code wasn't already initialized, add a "stop" instruction */
		instructions[code_length] = _ins_stop;

	state->base_pointer = get_edge_partition(false);

	if ((map=make_partition_map(state->base_pointer,&size))==NULL)
		{fatal_memory_error(memerr); goto end;}
	state->mr = map;
	state->page_count = size;

	state->df = (double*)(DEFAULT_V1_SIZE+stacks);
	state->ds = state->dc = data_count+state->df;
	state->lf = (sbcp_link*)state->ds;
	state->ls = state->lc = link_count+state->lf;
	/*state.sr = 0x80000000UL;*/
	state->pc = instructions;

#if TARGET_OS_MAC //&& DEBUG
	Debugger();
#endif
	do
	{
		long		steps = step_count<=0 ? LONG_MAX:step_count;

		global_idle_proc();
		if (print_lines)
			print_instruction(state->pc,state->pc-instructions);
		if ((err=sbcp_execute_lines(state,&steps,-step_count))!=0)
			break;
	} while(steps>0 && state->pc-instructions<code_length);

	if (err<0)
		fprint_string("##",stdout); /* for */
	fprint_form(stdout,"# execution result code #%d\n", err);
	if (err<0)
		{fprint_string("### ",stdout); fprint_string(execution_error_string(err),stdout);}
end:
	unload_memory_partitions();

	return 0;
}

static void unload_allocations(void)
{
	unload_memory_partitions();
	if (total_code!=NULL)
		{free(total_code); total_code = NULL, total_code_length = 0;}
}

#ifdef STANDALONE
# if TARGET_OS_MAC
#  include <Resources.h>
# else
#  error Stand-alone application build only supported for MacOS target.
# endif

void main()
{
	Handle			h;
	_uint8			*p;
	long			z;

	MoreMasters();
	MoreMasters();
	MoreMasters();
	MoreMasters();
	MoreMasters();

# if !TARGET_API_MAC_CARBON
	MaxApplZone();
	InitGraf((Ptr)&qd.thePort);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0);
# endif
	InitCursor();

	SetResLoad(0);
	h = GetIndResource('sbcE',1);
	SetResLoad(1);
	if (h==NULL || (z=GetResourceSizeOnDisk(h))<=0)
		return;

	if ((p=reallocate_memory_partition(NULL,z,false))==NULL)
		return;
	atexit(unload_allocations);

	ReadPartialResource(h,0,p,z);

	execute_code(p,z,0,0,0,false);
	/* error is ignored (no dialogs) */

	exit(0);
}
#else
static char *get_next_line(char *s, const char *e)
{
	do
	{
		char		c;

		if ((c=*s)=='\0')
			*s = ' '; /* fix-up to print without nulls */
		else if ((c+=-'\n')==0 || (c+='\n'-'\r')==0 || (c+='\r'-'\f')==0)
			break;
	} while(++s<e);

	return s;
}

static boolean print_compiler_error(sbcc_error err,
	char *text,
	long length,
	long offset,
	boolean extended_form,
	FILE *stream)
{
	static char		*error_strings[] =
 	{
		"syntax error",
		"memory error",
		"identifier not defined",
		"character not supported there",
		"expected operand(s) not found",
		"could not encode a (finite) value",
		"a label of that name already exists",
		"name exceeds limit of 255 characters",
		"internal error"
	};

	char			*s = offset+text, *e;

	if (err==_sbcc_no_error)
		return false;
	if ((unsigned)--err>(unsigned)_sbcc_internal_error)
		fprint_form(stream,"# unknown compiler error (%d)\n", (int)err);
	else
		fprint_form(stream,"# compiler error: %s\n", error_strings[(int)err]);

	if (!extended_form || offset<0)
		goto end;

	/* in order to print it in context, we'll need to scan to the start of the line */
	if (s>text)
	{
		do
		{
			char		c;

			if ((c=*s)=='\0' || (c+=-'\177')==0)
				*s = ' '; /* try to print without nulls or zero-width chars */
			else if ((c+='\177'-'\n')==0 || (c+='\n'-'\r')==0 || (c+='\r'-'\f')==0)
				{++s; break;}
		} while(--s>text);
		offset -= s-text;
	}

	/* print the error line and carrot pointing to the offset */
	/* for MPW, preceed each line with "#" in so it doesn't get executed */
	fputs(__ERR_INDENT_STR,stream);
	fwrite(s,(e=get_next_line(s,length+text))-s,1,stream);

	/* try to repeat the text's indent exactly first */
	text = s;

	if (e>s+1)
	{
		do
		{
			/* break at the first non-whitespace char */
#ifdef DBLSP_CHAR
			if (*s>' ' && *s!=DBLSP_CHAR)
#else
			if (*s>' ')
#endif
				break;
		} while(++s<e);

		if (offset<=0)
			goto zero_offset;
		fprintf(stream,"\n" __ERR_INDENT_STR "%* ^\n", offset);
	} else
	zero_offset:
		fputs("\n" __ERR_INDENT_STR "^\n",stream);
end:
	return err==_sbcc_memory_error; /* bail if it's a memory error */
}

#define STR_BUFFER_STREAM_SIZE			513 /* one sector worth (including the null) */

static char			_command_indent[] = __CMD_INDENT_STR;

#if sizeof(_command_indent)<=0
# error A non-positive sizeof() for a string?
#endif

/* returns true if there's more text */
static boolean read_first_line(char **buf, long *total_length, FILE *stream)
{
	char			*buffer = NULL, *t, c;
	long			length = 0, read_length = 0;

	if (buf!=NULL)
		buffer = *buf; /* otherwise the buffer is merely temporary */
	if (total_length!=NULL)
		length = *total_length;
	/* length check (negatives won't fly here) */
	if (length<0)
		length = 0;
	do
	{
		length += read_length, read_length = 0, c = 0;
		if ((t=realloc(buffer,length+STR_BUFFER_STREAM_SIZE))==NULL)
		{ /* instead of deallocating, signal invalidity (by negating the length) */
			length = -length;
			break;
		}
		buffer = t;
		if (fgets(length+buffer,STR_BUFFER_STREAM_SIZE,stream)==NULL
				|| (read_length=strlen(length+buffer))<=0)
			break;
		/* this is to avoid processing the indent (where stdin reads all of the line) */
#if defined(INHIBIT_INDENT_READ)
		if (length==0 && memcmp(buffer,_command_indent,sizeof(_command_indent)-1)==0)
			memmove(buffer,(sizeof(_command_indent)-1)+buffer,1+(read_length-=sizeof(_command_indent)-1));
#endif
		c = buffer[length+read_length-1];
	} while((c-='\n')!=0); /*(read_length>=STR_BUFFER_STREAM_SIZE-1)*/

	if (read_length>0)
		length += read_length;

	if (buf!=NULL)
	{ /* try minimizing allocation, and store the pointer */
		if (length>0 && (t=realloc(buffer,length))!=NULL)
			buffer = t;
		*buf = buffer;
	} else
		free(buffer);
	if (total_length!=NULL)
		*total_length = length;

	return c!=0;
}

#define BUFFER_STREAM_SIZE				4096 /* eight sectors worth */

static int compile_stream(FILE *stream,
	_uint8 **code,
	long *code_length,
	boolean verbose)
{
	char			*buffer = NULL;
	long			text_length = 0, err_offset = 0;
	sbcc_error		cerr;
	int				err = 0;

	if (stream==NULL)/* || ftell(stream)<0) -- Cmd-Period will ExitToShell in MPW */
		return -1; /* either too large or no stream */

	/*global_idle_proc();*/

	/* to avoid nulls from interfering in read_first_line, call only for stdin */
	if (stream!=stdin || read_first_line(&buffer,&text_length,stream))
	{ /* more than one line (or not stdin); finish reading */
		char		*t;
		long		read_length = 0;

		do
		{
			text_length += read_length;
			if ((t=realloc(buffer,text_length+BUFFER_STREAM_SIZE))==NULL)
				goto end;
			buffer = t;
		} while((read_length=fread(text_length+buffer,1,BUFFER_STREAM_SIZE,stream))==BUFFER_STREAM_SIZE);

		/* minimize allocation */
		if ((t=realloc(buffer,text_length+=read_length))!=NULL)
			buffer = t; /* failure here really to matter much (reduction in length) */
	}
end:
	if (buffer==NULL || text_length<0)
		err = memerr;
	*code_length = text_length;
	if (err==0)
	{
#if TARGET_OS_MAC && DEBUG
		Debugger();
#endif
		if ((cerr=sbcp_compile(buffer,code_length,code,&err_offset))!=_sbcc_no_error)
			if (print_compiler_error(cerr,buffer,text_length,err_offset,verbose,stderr))
				err = 1;
			else
				err = -1;
	}
	if (buffer!=NULL)
		free(buffer);

	return err;
}

static void do_command_line(void)
{
	_uint8			*code;
	long			code_length;
	int				err = 0;

	print_signature();
	fprint_string(" -- starting command line...\n",stdout);
	while(fputs(_command_indent,stdout)>=0)
	{
		if ((err=compile_stream(stdin,&code,&code_length,true))>0)
			break;
		if (err!=0) /* failure, don't execute (this time) */
			continue;
		if ((err=execute_code(code,code_length,0,0,0,false))!=0)
			{fprint_form(stderr,"### memory error in execution (%d)\n", err); exit(1);}
		unload_memory_partitions();
	}
}

static void append_code_to_attachments(_uint8 *code, long code_length)
{
	_uint8			*t = NULL;

	if (code==NULL || code_length<=0)
		return;
		/*{fprintf(stderr,"### Must have a length for the code! (%d)", code_length); exit(1); return;}*/
	if ((t=realloc(total_code,total_code_length+code_length))==NULL)
		{fatal_memory_error(memerr); return;}
	memcpy(total_code_length+(total_code=t),code,code_length);
	total_code_length += code_length;
}

/* implemented so multiple attachments can be made */
static boolean compile_attachment(char *text, long length, boolean verbose)
{
	_uint8			*code = NULL;
	long			code_length, err_offset;
	sbcc_error		cerr;
	boolean			result = true;

#if TARGET_OS_MAC && DEBUG
	Debugger();
#endif
	/* if nothing to compile (assuming for negative values as well) */
	if ((code_length=length)>0 && text!=NULL)
		if ((cerr=sbcp_compile(text,&code_length,&code,&err_offset))!=_sbcc_no_error)
		{
			print_compiler_error(cerr,text,length,err_offset,verbose,stderr);
			/* because all errors from here will stop further execution of the command
			  line, the error code can be ignored */
			result = false;
		} else
			append_code_to_attachments(code,code_length);
	if (code!=NULL)
		free(code);

	return result;
}

static const char *nerstring(long int i)
{
	switch(i%10)
	{
	case 1: return "st";
	case 2: return "nd";
	case 3: return "rd";

	default: return "th";
	}
}

void main(int argc, char **argv)
{
	sbcp_dump_info	info;
	FILE			*infile = NULL;
	_uint8			*code = NULL;
	char			**a = argv, *s = a[1];
	char			*dump_filepath = NULL;
	long			code_length = 0;
	int				c = argc, err = 0, step_count = 0, zdata = 0, zlink = 0;
	boolean			disassemble = false, print_lines = false, verbose = false;
	boolean			execute = true, has_attachment = false;

	info.offset_to_code = 0; /* so offsets in disassembly show up correctly */

	atexit(unload_allocations);

	if (--c<=0)
	{
		if (c==0) /* otherwise, our call is weird */
			do_command_line();
		exit(0);
	}

	while((s=*++a)[0]=='-')
	{
		if (*++s=='i' && s[1]=='\0')
		{
			print_signature();
			fprint_string("\n" __ERR_INDENT_STR " Compiled",stdout);
#if defined(__SC__)
			fprint_form(stdout," with SC %X.%02X", __SC__>>8,__SC__&0xFF);
/*# ifdef SC_MPW
	"(using MPW)"
# endif*/
#elif defined(__MRC__)
			fprint_form(stdout," with MrC %X.%02X", __MRC__>>8,__MRC__&0xFF);
#endif
			fprint_string(" at: " __DATE__ " " __TIME__ " (probably Eastern U.S.)\n",stdout);
			exit(0);
		}
		if (s[0]=='?' || s[0]=='q') /* can ignore anything following */
			goto print_message;
		if (s[0]=='v' && s[1]=='\0')
			verbose = true;
		else if (s[0]=='e' && s[1]=='\0')
		{
			if (--c==0)
				goto missing_parameter;
			s = *++a;
			if (!compile_attachment(s,strlen(s),verbose))
				{exit(1); return;}
			has_attachment = true;
		} else if (s[0]=='s' && s[1]=='\0')
			fall_silent = true;
		else if (s[0]=='p' && s[1]=='\0')
			print_lines = true;
		else if (s[0]=='d' && s[1]=='\0')
			disassemble = true;
		else if (strcmp(s,"pf24")==0)
		{
			const char		*t;
			double			v;
			long int		i;

			if (--c==0)
				goto missing_parameter;
			s = *++a;
			if ((t=sbcp_parse_number(s,strlen(s)+s,&v,true))==NULL)
				{fprintf(stderr,"### %s - bad number\n", argv[0]); exit(1);}
			/* silent option only eliminates warnings for -pf24 option */
			fprintf(stdout,"0x%06X", sbcp_make_float24(v));
			if (!sbcp_float24_range_check(v))
				fprint_string(" (out of range)",stdout);
			if ((i=t-s)!=strlen(s))
				fprint_form(stdout," - parsing stopped after %d%s char", i,nerstring(i));
			fputc('\n',stdout);
			exit(0);
		} else if (strcmp(s,"dump")==0)
		{
			if (--c==0)
				goto missing_parameter;
			dump_filepath = *++a;
		} else if (strcmp(s,"load")==0)
		{
			FILE		*file;

			if (--c==0)
				goto missing_parameter;
			if ((file=fopen(*++a,"r+"))==NULL)
				{fprint_form(stderr,"### %s - failed to open '%s'\n", argv[0],a); exit(1);}
			err = sbcp_load_code(file,&code_length,&code,&info,verbose);
			fclose(file);

			if (err!=0)
				{fatal_memory_error(err); return;}
		} else if ((*a)[1]=='\0')
			infile = stdin;
		else if (strcmp(s,"zdata")==0)
		{
			if (--c==0)
				goto missing_parameter;
			zdata = atoi(*++a);
		} else if (strcmp(s,"zlink")==0)
		{
			if (--c==0)
			{
			missing_parameter:
				fprint_form(stderr,"### missing parameter for '%s'\n", argv[0],s); exit(1);
			}
			zlink = atoi(*++a);
		} else if (strcmp(s,"noexec")==0)
			execute = false;
		else
		{
			fprint_form(stderr,"### %s - unrecognized option '%s'\n#\n", argv[0],s);
		print_message:
			fprint_form(stderr,"### usage: %s [options] [file]\n", argv[0]);
			fprint_string(
"#\n"
"# (no parameters): command line prompt\n"
"#\t-           use stdin as input\n"
"#\t-? | -q     get info only (what you are seeing now)\n"
"#\t-d          only disassemble result\n"
"#\t-dump xxx   compile and dump code to file xxx\n"
"#\t-e xxx      compile and execute xxx\n"
"#\t-i          print version info (only)\n"
"#\t-load xxx   load and execute file xxx\n"
"#\t-pf24 xxx   print a number as a float24 in hex (only)\n"
"#\t-noexec     no execution of code\n"
"#\t-p          print executed lines\n"
"#\t-s          silent (also silences errors)\n"
"#\t-step n     set stepping count, in lines or instruction count (negative)\n"
"#\t-v          verbose output (dump all headers and whatnot)\n"
"#\t-zdata n    set data stack size (entry count); default: 8192\n"
"#\t-zlink n    set link stack size (entry count); default: 4096\n"
"#\n"
"#  Warning: Any text-input filepath may be ignored if more than one is given!\n"
				,stderr);
			exit(1);
		}
		if (--c==0)
			break;
	}

	if (fall_silent)
		print_lines = verbose = false; /* silence printing options */

	if (code==NULL)
	{
		if (infile==NULL)
			if (c!=1)
			{
				if (c>0 || total_code_length<=0)
				{
					fprint_form(stderr,c<=0 ? "### %s - expected filepath or input\n":"### %s - expected one filepath parameter\n", argv[0]);
					exit(1);
				}
			} else if ((infile=fopen(s,"r+"))==NULL)
				{fprint_form(stderr,"### %s - failed to open '%s'\n", argv[0],s); exit(1);}

		if (infile!=NULL)
		{
			err = compile_stream(infile,&code,&code_length,verbose);

			if (infile!=stdin)
				fclose(infile);
			infile = NULL;
		}

		if (err!=0)/* || (code==NULL && total_code_length<=0))*/
			{fprint_form(stderr,"### %s - error #%d in compilation\n", argv[0],err); exit(1);}
	}

	/* order code so attachments come first */
	append_code_to_attachments(code,code_length);
	if (code!=NULL)
		free(code);

	if (dump_filepath==NULL)
		if (disassemble)
			disassemble_code(total_code,total_code_length,info.offset_to_code,stdout);
		else if (execute)
		{
			if (verbose)
				fprint_form(stdout,"# %d byte(s) of code", total_code_length);
			if ((err=execute_code(total_code,total_code_length,zdata,zlink,step_count,print_lines))!=0)
				{fprint_form(stderr,"### %s - memory error in execution (%d)\n", argv[0],err); exit(1);}
		}
	else if (disassemble)
		{fprint_form(stderr,"### %s - conflicting options '-d' and '-dump'\n", argv[0]); exit(1);}
	else
		sbcp_dump_code(total_code,total_code_length,dump_filepath,zdata,zlink,has_attachment);

	exit(0);
}
#endif
