/*
 sbcp.h
  "stack based core prototype" multi-purpose include

 Version: 0.1.8
 Created: January 19, 2007 9:46 PM EDST
 Revised: June 20, 2008 3:49 PM EDST

  Warning: Some macros may use parameters more than once!

 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.  If changes have been made to the original
 * copy, please make it clear.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.

Monday, January 22, 2007 9:20:42 PM
A.P.: hmmm.  this seems pretty tishty.
Monday, November 26, 2007 3:20 AM
  renamed link_entry to sbcp_link_entry/sbcp_link.
Tuesday, November 27, 2007 6:23 PM
  replaced `byte' with `UInt8'.
Thursday, November 29, 2007 12:02 PM
  moved all of the core material to sbcp_core.h (this file used to be sbcp_core.h).
Sunday, January 13, 2008 5:04 PM
  extending the state structure for... more registers.
Friday, June 20, 2008 3:40 PM
  division routines now always return lower 32 bits (no '_').
*/

#ifndef __SBCP_H
# define __SBCP_H

# if PRAGMA_ONCE
#  pragma once
# endif

# define SBCP_VERSION                   0x0017
# define SBCP_NAME_STRING               "sbcp"
# define SBCP_VERSION_STRING            "0.1.7"

#if !defined(rez) && !defined(derez)
/*#include <math.h>*/

# ifdef __cplusplus
   extern "C" {
# endif

# if PRAGMA_IMPORT
#  pragma import on
# endif

# if (defined(env68k) || defined(envppc)) /*&& defined(TARGET_OS_MAC)*/
#  define SBCP_UNALIGNED_RW_BE
# endif

# if 1 /*!TYPE_BOOL*/
   typedef unsigned char                boolean;
#  ifndef true
#   define true                         1
#  endif
#  ifndef false
#   define false                        0
#  endif
# endif

 /* configure the environment so `int' is four bytes */
#if 1/*defined(__MACTYPES__)*/
   typedef char                         _int8;
   typedef signed char                  _sint8;
   typedef unsigned char                _uint8;
   typedef short                        _int16;
   typedef unsigned short               _uint16;
   typedef int                          _int32;
   typedef unsigned int                 _uint32;

  /* native `word' types; 16 bit on most CISC, 32 bit on RISC */
#  if defined(env68k) || defined(envx86)
    typedef short                       _word;
    typedef unsigned short              _uword;
#  else
    typedef int                         _word;
    typedef unsigned int                _uword;
#  endif
# endif

# if TYPE_LONGLONG
#  ifdef LONGLONG_TYPENAME
#   define _LONGLONG_TYPE               LONGLONG_TYPENAME
#  else
#   define _LONGLONG_TYPE               long long
#  endif

   typedef _LONGLONG_TYPE               _int64;
   typedef unsigned _LONGLONG_TYPE      _uint64;
#  undef _LONGLONG_TYPE
# else
#  if ((char)(0x100>>8))==0
    /* little endian */
    typedef struct _int64{_uint32 lo; _int32 hi;} _int64;
    typedef struct _uint64{_uint32 lo, hi;} _uint64;
#  else
    typedef struct _int64{_int32 hi; _uint32 lo;} _int64;
    typedef struct _uint64{_uint32 hi, lo;} _uint64;
#  endif
# endif

# ifndef _int64_param
#  define _int64_param                  void*
# endif
# ifndef _uint64_param
#  define _uint64_param                 void*
# endif

 /* for 64 bit math to work on all systems */
/*extern void _int64_shl(_int64_param, _uint8);*/
/*extern void _int64_shr(_int64_param, _uint8);*/
/*extern void _uint64_shr(_uint64_param, _uint8);*/

/*extern void _int64_addhl(_int64_param, _int32, _uint32);*/
/*extern void _int64_subhl(_int64_param, _int32, _uint32);*/

  extern void _int64_setx(_int64_param, long double);
  extern void _uint64_setx(_uint64_param, long double);

  extern void _mul64_s32(_int64_param, _int32, _int32);
  extern void _mul64_u32(_uint64_param, _uint32, _uint32);

  extern _uint32 _mulhi32_u32(_uint32, _uint32);

  extern void _int64_mulu32(_uint64_param, _uint32);

#  define int64_half(n)                 do{int64_addhl(n,0,(signed)int64hi(n)<0); \
     int64_shr(n,1);}while(0)
#  define uint64_half(n)                uint64_shr(n,1)

#  define mulhi32_u32(a,b)              _mulhi32_u32(a,b)

# if TYPE_LONGLONG
#  define int64_neg(n)                  do{(n)=-(_int64)(n);}while(0)
#  define int64_add(n,x)                do{(n)+=(_int64)(x);}while(0)
#  define int64_sub(n,x)                do{(n)+=(_int64)(x);}while(0)
#  define int64_shl(n,x)                do{(n)<<=x;}while(0)
#  define int64_shr(n,x)                do{(n)=((_int64)(n)>>x);}while(0)
#  define uint64_shr(n,x)               do{(n)=((_uint64)(n)>>x);}while(0)

#  define int64_shri(n,i)               do{(n)=((_int64)(n)>>i);}while(0)
#  define uint64_shri(n,i)              do{(n)=((_uint64)(n)>>i);}while(0)

#  define int64_adds32(n,x)             do{(n)+=(_int32)(x);}while(0)
#  define int64_subs32(n,x)             do{(n)+=(_int32)(x);}while(0)
#  define int64_addu32(n,x)             do{(n)+=(_uint32)(x);}while(0)
#  define int64_subu32(n,x)             do{(n)+=(_uint32)(x);}while(0)
#  define int64_addhl(n,x,y)            do{(n)+=((_uint64)(x)<<32)+(_uint32)(y);}while(0)
#  define int64_subhl(n,x,y)            do{(n)-=((_uint64)(x)<<32)+(_uint32)(y);}while(0)

#  define int64_or(n,x)                 do{(n)|=(_uint64)(x);}while(0)
#  define int64_and(n,x)                do{(n)&=(_uint64)(x);}while(0)
#  define int64_xor(n,x)                do{(n)^=(_uint64)(x);}while(0)
#  define int64_orhl(n,x,y)             do{(n)|=((_uint64)(x)<<32)+(_uint32)(y);}while(0)
#  define int64_andhl(n,x,y)            do{(n)&=((_uint64)(x)<<32)+(_uint32)(y);}while(0)
#  define int64_xorhl(n,x,y)            do{(n)^=((_uint64)(x)<<32)+(_uint32)(y);}while(0)

#  define int64_eq(a,b)                 ((_int64)(a)==(_int64)(b))
#  define int64_u32eq(a,b)              ((_int64)(a)==(_uint32)(b))
#  define int64_u32gt(a,b)              ((_int64)(a)>(_uint32)(b))
#  define uint64_u32gt(a,b)             ((_uint64)(a)>(_uint32)(b))
#  define int64_u32ge(a,b)              ((_int64)(a)>=(_uint32)(b))
#  define uint64_u32ge(a,b)             ((_uint64)(a)>=(_uint32)(b))

#  define int64_sethl(n,x,y)            do{(n)=((_uint64)(x)<<32)+(_uint32)(y);}while(0)
#  define int64_setl(n,x)               do{(n)=0L+(x);}while(0)
#  define int64_setx(n,x)               do{(n)=(_int64)(0.0+(x));}while(0)
#  define uint64_setx(n,x)              do{(n)=(_uint64)(0.0+(x));}while(0)
#  define int64_to_l(n)                 (long int)(n)
#  define int64_to_u(n)                 (unsigned long int)(n)
#  define int64_to_x(n)                 (0.0L+(n))

#  define int64hi(x)                    ((x)>>32)
#  define int64lo(x)                    ((x)&-1UL)
#  define int64z(x)                     ((_uint64)((x)>>0)==0)
#  define int64n(x)                     ((_int64)(x)<0)
#  define int64p(x)                     ((_int64)(x)>=0)

#  define mul64_s32(n,a,b)              do{(n)=(_int32)(a)*(_int32)(b);}while(0)
#  define mul64_u32(n,a,b)              do{(n)=(_uint32)(a)*(_uint32)(b);}while(0)

#  define int64_muls32(n,x)             do{(n)*=(_int32)(x);}while(0)
#  define int64_mulu32(n,x)             do{(n)*=(_uint32)(x);}while(0)

#  ifdef __MRC__
#   undef mulhi32_u32
#   define mulhi32_u32(x,y)             __mulhw(x,y)
#  endif

#  define int64_divs32(x,y)             (_int32)((x)=(_int64)(x)/(_int32)(y))
#  define uint64_divu32(x,y)            (_uint32)((x)=(_uint64)(x)/(_uint32)(y))
# else
#  define int64_add(n,x)                _int64_addhl(&(n),(x).hi,(x).lo)
#  define int64_sub(n,x)                _int64_subhl(&(n),(x).hi,(x).lo)

#  define int64_divs32(x,y)             _int64_divs32(&(x),y)
#  define uint64_divu32(x,y)            _uint64_divu32(&(x),y)

#  define int64_shl(n,i)                do{_uint8 __i=(i)&0x7F; \
     _int64*__n=(_int64*)&(n); _uint32 __t=__n->lo; if((__i&=127)<=32) \
     __n->lo=__t<<__i,__n->hi=(__n->hi<<__i)|(__t>>32-__i); else if((__i-=32)>32) \
     __n->hi=0,__n->lo=0; else __n->hi=__t>>=__i,__n->lo=0;}while(0)
#  define int64_shr(n,i)                do{_uint8 __x=(i)&0x7F; \
     _int64*__n=(_int64*)&(n); _uint32 __t=__n->hi; if(__x<=31) \
     __n->lo=(__t<<32-__x)|(__n->lo>>__x),__n->hi=(signed)__t>>__x; else \
     if((__x-=32)<=31) __n->lo=__n->hi>>__x; else __n->hi=__n->lo=__n->hi>>32;}while(0)
#  define uint64_shr(n,i)               do{_uint8 __x=(i)&0x7F; \
     _uint64*__n=(_uint64*)&(n); _uint32 __t=__n->hi; if(__x<=31) \
     __n->lo=(__t<<32-__x)|(__n->lo>>__x),__n->hi=__t>>__x; else if((__x-=32)<=31) \
     __n->lo=__n->hi>>__x; else __n->hi=__n->lo=__n->hi>>32;}while(0)

#  define int64_adds32(n,x)             _int64_addhl(&(n),x>>32,x)
#  define int64_subs32(n,x)             _int64_subhl(&(n),x>>32,x)
#  define int64_addu32(n,x)             _int64_addhl(&(n),0,x)
#  define int64_subu32(n,x)             _int64_subhl(&(n),0,x)
#  define int64_addhl(n,x,y)            _int64_addhl(&(n),x,y)
#  define int64_subhl(n,x,y)            _int64_subhl(&(n),x,y)

#  define int64_or(n,x)                 do{(n).hi|=(x).hi,(n).lo|=(x).lo;}while(0)
#  define int64_and(n,x)                do{(n).hi&=(x).hi,(n).lo&=(x).lo;}while(0)
#  define int64_xor(n,x)                do{(n).hi^=(x).hi,(n).lo^=(x).lo;}while(0)
#  define int64_orhl(n,x,y)             do{(n).hi|=x,(n).lo|=y;}while(0)
#  define int64_andhl(n,x,y)            do{(n).hi&=x,(n).lo&=y;}while(0)
#  define int64_xorhl(n,x,y)            do{(n).hi^=x,(n).lo^=y;}while(0)

#  define int64_eq(a,b)                 ((a).hi==(b).hi&&(a).lo==(b).lo)
#  define int64_u32eq(a,b)              ((a).hi==0&&(a).lo==(b))
#  define int64_u32gt(a,b)              ((signed)((a).hi)>=0&&((a).lo>(_uint32)(b)||(a).hi!=0))
#  define uint64_u32gt(a,b)             ((a).lo>(_uint32)(b)||(a).hi!=0)
#  define int64_u32ge(a,b)              ((signed)((a).hi)>=0&&((a).lo>=(_uint32)(b)||(a).hi!=0))
#  define uint64_u32ge(a,b)             ((a).lo>=(_uint32)(b)||(a).hi!=0)

#  define int64_sethl(n,x,y)            do{(n).hi=x;(n).lo=y;}while(0)
#  define int64_setl(n,x)               do{(n).hi=(x)>>32;(n).lo=x;}while(0)
#  define int64_setx(n,x)               _int64_setx(&(n),x)
#  define uint64_setx(n,x)              _uint64_setx(&(n),x)
#  define int64_to_l(n)                 (((_int64*)&(n))->hi \
     ==(signed)((_int64*)&(n))->lo>>32?((_int64*)&(n))->lo
     :0x7FFFFFFFL+((unsigned)((_int64*)&(n))->hi>>32))
#  define int64_to_u(n)                 (-((n).hi!=0)|(n).lo)
#  define int64_to_x(n)                 ((n).hi*4294967296.0L+(n).lo)

#  define int64hi(x)                    (0+(x).hi)
#  define int64lo(x)                    (0+(x).lo)
#  define int64z(x)                     ((x).hi==0&&(x).lo==0)
#  define int64n(x)                     ((signed)((x).hi)<0)
#  define int64p(x)                     (((signed)((x).hi)>=0&&(x).lo!=0)||(signed)((x).hi)>0)

#  define mul64_s32(n,a,b)              _mul64_s32(&(n),a,b)
#  define mul64_u32(n,a,b)              _mul64_u32(&(n),a,b)

#  define int64_muls32(n,x)             do{_int64*__n=(_int64*)&(n); \
      _int32 __x; if((__x=x)<0) {__x=-__x,__n->hi=-__n->hi; \
      if((__n->lo=-__n->lo)!=0) ++__n->hi;} _int64_mulu32(__n,__x);}while(0)
#  define int64_mulu32(n,x)             _int64_mulu32(&(n),x)

#  ifdef env68k
#   undef int64_half
#   undef uint64_half

#   define int64_neg(n)                 _int64_neg(&(n))
#   define int64_half(n)                _int64_half(&(n))
#   define uint64_half(n)               _uint64_half(&(n))

#   pragma parameter _int64_neg(__A0)
    extern void _int64_neg(_int64_param) = {0x44A8, 4, 0x4090};
#   pragma parameter _int64_addhl(__A0,__D1,__D2)
    extern void _int64_addhl(_int64_param,_int32,_uint32) = {0x2018, 0xD590, 0xD181, 0x2100};
#   pragma parameter _int64_subhl(__A0,__D1,__D2)
    extern void _int64_subhl(_int64_param,_int32,_uint32) = {0x2018, 0x9590, 0x9181, 0x2100};

#   pragma parameter _mul64_s32(__A0,__D1,__D2)
    extern void _mul64_s32(_int64_param,_int32,_int32) = {0x4C01, 0x2C01, 0x20C1, 0x2082};
#   pragma parameter _mul64_u32(__A0,__D1,__D2)
    extern void _mul64_u32(_uint64_param,_uint32,_uint32) = {0x4C01, 0x2401, 0x20C1, 0x2082};

#   pragma parameter __D1 _mulhi32_u32(__D1,__D2)
    extern _uint32 _mulhi32_u32(_uint32,_uint32) = {0x4C01, 0x2401};

#   pragma parameter _int64_mulu32(__A0,__D2)
    extern void _int64_mulu32(_uint64_param,_uint32) =
     {0x2018, 0x4C02, 0, 0x4C10, 0x2401, 0xD280, 0x2082, 0x2101};

#   pragma parameter __D1 _int64_divs32(__A0,__D2)
    extern _uint32 _int64_divs32(_int64_param,_int32) =
     {0x2228, 4, 0x2010, 0x6A04, 0x4481, 0x4080, 0xB598, 0x2082, 0x6A02, 0x4490,
      0x4C50, 2, 0x4C50, 0x1402, 0x4AA0, 0x6A06, 0x4482, 0x4481, 0x4080, 0x20C0,
      0x2081};
#   pragma parameter __D1 _uint64_divu32(__A0,__D2)
    extern _uint32 _uint64_divu32(_uint64_param,_uint32) =
     {0x2018, 0x2210, 0x2082, 0x4C50, 2, 0x4C50, 0x1402, 0x2081, 0x2100};

#   pragma parameter _int64_half(__A0)
    extern void _int64_half(_int64_param) =
     {0x2018, 0x5BC1, 0x49C0, 0xD290, 0x4080, 0x4480, 0xE280, 0xE291, 0x2081, 0x2100};
#   pragma parameter _uint64_half(__A0)
    extern void _uint64_half(_int64_param) =
     {0x2018, 0x2210, 0xE288, 0xE291, 0x2081, 0x2100};
#  else
#   define int64_neg(n)                 do{_int64*__n=(_int64*)(n); \
      __n->hi=-__n->hi-((__n->lo=-__n->lo)!=0);}while(0)
#   define _int64_addhl(n,x,y)          do{_int64*__n=(_int64*)(n); _int32 __x=x; \
      _uint32 __y=y,__t=__n->lo,__n->hi+=(__t>(__n->lo+=__y)),__n->hi+=__x;}while(0)
#   define _int64_subhl(n,x,y)          do{_int64*__n=(_int64*)(n); _int32 __x=x; \
      _uint32 __y=y,__t=__n->lo,__n->hi-=(__t<(__n->lo-=__y)),__n->hi-=__x;}while(0)
#  endif
# endif

enum
{ /* emulator errors */
    _err_null_pointer           = -1000, /* parameter error */
    _err_floor_above_ceiling    = -1001, /* parameter error */
    _err_stack_overflow         = -1002, /* runtime error */
    _err_stack_underflow        = -1003, /* runtime error */
    _err_sensitive_register     = -1004  /* (for protection) */
};

/* ---------- structures */

typedef struct sbcp_link/*(16)*/
{
    _int64          return_pc, return_ds;
} sbcp_link_entry, sbcp_link;

typedef struct sbcp_state/*(1096+)*/
{
    _int64          instance[128];
/*0x400*/
   /* status register (mode is undefined in the emulator) */
    _uint32         sr; /* [boundaries.1] [privilege.1] [exception.1] [break.1] [int_level.4] [cache_status.8] [vector_status.16] */
   /* floating-point register */
    _uint32         fpr; /* [fpcr.16] [fpsr.16] -- read sbcp_core.h for details */

   /* offset and size registers (for indexed displacement and bitfields) */
    _uint32         fr, zr;
/*0x410*/
   /* result register (result parameters can be added manually for function calls) */
    double          rs;

   /* other registers */
    _int64          v1; /* points to the exception vector table (_int32 each) */
/*0x420*/
   /* the base pointer is the offset for all emulated pointers */
    _uint8          *base_pointer; /* cannot be NULL */

   /* the cache map is a reference table to the cache tables (in the fake CPU) */
   /* each byte makes up for all mapped space in 65536 byte pages (16 bits) */

   /* for each representing byte: [writable.1] [table_index.7]; */
   /* 0bx0000000 means unmapped; all other values mean they are mapped to a
     cache table; 0bx1111111 refers to no table (uncached, but still mapped) */
    _uint8          *mr; /* memory map; cannot be NULL */
    _uint32         page_count; /* number of representing entries in map */

   /* current stack positions (should be valid in memory map) */
    double          *ds;
    sbcp_link       *ls; /* format of link entry is in sbcp_core.h */

   /* program counter */
    _uint8          *pc; /* must be valid in memory map */

   /* data/link floor/ceiling */
    double          *df, *dc; /* must be valid in memory map */
    sbcp_link       *lf, *lc; /* must be valid in memory map */
} sbcp_state;

/* ---------- prototypes */

/* for maximum_lines, NULL represents "unlimited" */
/* the returned result is an error code or exception vector index,
  whereas the exception couldn't be handled by the emulator */
extern int sbcp_execute_lines(sbcp_state *state,
  long *maximum_lines, /* non-positive contents results in no execution */
  long int maximum_instructions); /* pass non-positive value to run indefinetly */

# ifdef PRAGMA_IMPORT_OFF
#  pragma import off
# elif PRAGMA_IMPORT
#  pragma import reset
# endif

# ifdef __cplusplus
   }
# endif

#endif /*!defined(rez) && !defined(derez)*/
#endif /*!defined(__SBCP_H)*/
