/*
 sbcp.r
  for Rez'ing sbcp code
  
  For sbcp version 0.1.7

 Created: 2007.11.27 22:54 GMT
 Revised: 2008.01.13 07:00 GMT

 Warning: Until version 1.0, the instruction set may change in implementation.

 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

/*Echo '#include "::sbcp:sbcp.r"'n'resource ''sbcE'' (0) {{nobreak, add{current}; nobreak, illegal{}};};' | Rez*/

/*
// Example `sbcE' resource:
resource 'sbcE' (0,"Example...")
{
	{ // to compute the hypotenuse of three and four...
		nobreak, nop{-1};
		nobreak, pshi{pos,sbcp_three};	// push #3.0
		nobreak, mul{0};				// multiply by self (9)
		nobreak, pshi{pos,sbcp_four};	// push #4.0
		nobreak, mul{0};				// multiply by self (16)
		nobreak, add{current};			// add the two entries (25)
		nobreak, sqrt{current};			// square root (5)
		nobreak, popd{current};			// remove entry
		nobreak, invalid{illegal};		// exception thrown (idiot ends program)
	}
};
*/

/* one half: -1+sbcp_one, one quarter: -2+sbcp_one, etc. */
#define sbcp_one					63,0
#define sbcp_two					64,0
#define sbcp_three					64,0x8000
#define sbcp_four					65,0
#define sbcp_five					65,0x4000
#define sbcp_six					65,0x8000
#define sbcp_seven					65,0xC000
#define sbcp_eight					66,0
#define sbcp_nine					66,0x2000
#define sbcp_ten					66,0x4000
#define sbcp_eleven					66,0x6000
#define sbcp_twelve					66,0x8000
#define sbcp_thirteen				66,0xA000
#define sbcp_fourteen				66,0xC000
#define sbcp_fifteen				66,0xE000
#define sbcp_sixteen				67,0
#define sbcp_seventeen				67,0x1000
#define sbcp_eighteen				67,0x2000
#define sbcp_nineteen				67,0x3000
#define sbcp_twenty					67,0x4000
#define sbcp_thirty					67,0xE000
#define sbcp_thirty_two				68,0
#define sbcp_forty					68,0x4000
#define sbcp_fifty					68,0x9000
#define sbcp_sixty					68,0xE000
#define sbcp_sixty_four				69,0
#define sbcp_seventy				69,0x1800
#define sbcp_eighty					69,0x4000
#define sbcp_ninety					69,0x6800
#define sbcp_hundred				69,0x9000
#define sbcp_thousand				72,0xF400
/* anything beyond this varies in English (new "million" = old English "milliard") */

type 'sbcE'
{
	wide array instructions
	{
		boolean		nobreak, break;
		switch
		{
		case nop:
			key bitstring[7] = 0;
			bitstring[24];
		case ads:
			key bitstring[7] = 1;
			bitstring[24];
		case pshi:
			key bitstring[7] = 2;
			boolean pos, neg;
			bitstring[7]; /* exponent */
			integer; /* mantissa */
		case pshn:
			key bitstring[7] = 6;
			bitstring[24]; /* offset */

		case nea:
			key bitstring[7] = 3;
			bitstring[24]; /* offset */
		case exg:
			key bitstring[7] = 7;
			bitstring[24] current = 0x800000;
		case stop:
			key bitstring[7] = 4;
			bitstring[24];
		case ret:
			key bitstring[7] = 5;
			bitstring[24];

		case setrs:
			key bitstring[7] = 8;
			bitstring[24] current = 0x800000;
		case getrs:
			key bitstring[7] = 9;
			bitstring[24] current = 0x800000;
		case pshd:
			key bitstring[7] = 10;
			bitstring[24] current = 0x800000;
		case popd:
			key bitstring[7] = 11;
			bitstring[24] current = 0x800000;

		case orc:
			key bitstring[7] = 12;
			bitstring[24] current = 0x800000;
		case andc:
			key bitstring[7] = 13;
			bitstring[24] current = 0x800000;
		case addc:
			key bitstring[7] = 15;
			bitstring[24] current = 0x800000;
		case cmpd:
			key bitstring[7] = 14;
			bitstring[24] current = 0x800000;

		case rdd:
			key bitstring[7] = 16;
			byte;	integer;
		case rds:
			key bitstring[7] = 17;
			byte;	integer;
		case rdb:
			key bitstring[7] = 18;
			byte;	integer;
		case rdfd:
			key bitstring[7] = 19;
			boolean nosign, sign;
			bitstring[7]; /* instance index */
			integer; /* displacement */

		case wdd:
			key bitstring[8] = 40;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wddu:
			key bitstring[8] = 41;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wds:
			key bitstring[7] = 42;
			boolean noupdate, update;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdsu:
			key bitstring[7] = 43;
			boolean noupdate, update;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdb:
			key bitstring[7] = 44;
			boolean noupdate, update;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdbu:
			key bitstring[7] = 45;
			boolean noupdate, update;
			bitstring[7]; /* instance index */
			integer; /* displacement */

		case wdfd:
			key bitstring[7] = 24;
			boolean nosign, sign;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case rdfe:
			key bitstring[7] = 27;
			boolean nosign, sign;
			bitstring[7]; /* instance index */
			byte; /* displacement */
			bitstring[3] = 0;
			bitstring[5]; /* width */

		case wddu:
			key bitstring[8] = 56;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdsu:
			key bitstring[8] = 58;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdbu:
			key bitstring[8] = 60;
			bitstring[7]; /* instance index */
			integer; /* displacement */
		case wdfe:
			key bitstring[7] = 31;
			boolean nosign, sign;
			bitstring[7]; /* instance index */
			byte; /* displacement */
			bitstring[3] = 0;
			bitstring[5]; /* width */

		case or:
			key bitstring[7] = 32;
			bitstring[24] current = 0x800000;
		case and:
			key bitstring[7] = 33;
			bitstring[24] current = 0x800000;
		case exor:
			key bitstring[7] = 34;
			bitstring[24] current = 0x800000;
		case snz:
			key bitstring[7] = 35;
			bitstring[24] current = 0x800000;

		case sge:
			key bitstring[7] = 36;
			bitstring[24] current = 0x800000;
		case sle:
			key bitstring[7] = 37;
			bitstring[24] current = 0x800000;
		case slt:
			key bitstring[7] = 38;
			bitstring[24] current = 0x800000;
		case sgt:
			key bitstring[7] = 39;
			bitstring[24] current = 0x800000;

		case add:
			key bitstring[7] = 40;
			bitstring[24] current = 0x800000;
		case mul:
			key bitstring[7] = 41;
			bitstring[24] current = 0x800000;
		case div:
			key bitstring[7] = 42;
			bitstring[24] current = 0x800000;
		case scal:
			key bitstring[7] = 43;
			bitstring[24] current = 0x800000;

		case neg:
			key bitstring[7] = 44;
			bitstring[24] current = 0x800000;
		case abs:
			key bitstring[7] = 45;
			bitstring[24] current = 0x800000;
		case rndz:
			key bitstring[7] = 46;
			bitstring[24] current = 0x800000;
		case sqrt:
			key bitstring[7] = 47;
			bitstring[24] current = 0x800000;

		case jn:
			key bitstring[7] = 48;
			bitstring[24];
		case jnz:
			key bitstring[7] = 49;
			bitstring[24];
		case cn:
			key bitstring[7] = 50;
			bitstring[24];
		case cnz:
			key bitstring[7] = 51;
			bitstring[24];

		case iad:
			key bitstring[7] = 52;
			byte;	integer;
		case iar:
			key bitstring[7] = 53;
			byte;	integer;
		case iaa:
			key bitstring[7] = 54;
			byte;	integer;
		case ci:
			key bitstring[7] = 55;
			byte;	integer;

		case rct:
			key bitstring[7] = 56;
			byte;	integer;
		case wct:
			key bitstring[7] = 57;
			byte;	integer;
		case setrg:
			key bitstring[7] = 58;
			byte;	fill word;
		case getrg:
			key bitstring[7] = 59;
			byte;	fill word;

		case setds:
			key bitstring[7] = 60;
			bitstring[24];
		case setpc:
			key bitstring[7] = 61;
			bitstring[24];
		case trap:
			key bitstring[7] = 62;
			bitstring[24];
		case illegal:
			key bitstring[7] = 63;
			bitstring[24];
		};
	};
};
